/* filelog.c
 *
 * This defines a machanism to log either in a file or using syslog.
 *
 * I hereby place this in the public domain - Hugo Haas, 1998.
 */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#define LOG_FILE "/var/log/iplogger.log"

struct logger {
  short file;
  void (*f)(int, char*, ...);
};

void filelog(int priority, char *format, ...)
{

  int f = open((char *) LOG_FILE, O_WRONLY | O_APPEND | O_CREAT, 0640);

  if (f>0) {
    char buffer[1024];
    char date[27];
    time_t current = time(NULL);
    va_list msg;

    va_start(msg,format);
    vsprintf(buffer,format,msg);
    va_end(msg);

    sprintf(date, asctime(localtime(&current)));
    write(f, date, strlen(date)-6);
    write(f, " ", 1);
    write(f, buffer, (strlen(buffer) < 1023) ? strlen(buffer) : 1023 );
    write(f, "\n", 1);
    close(f);
  }
}
